## kadu 0.9.0

=== CMakeLists.txt ===
project (kadu)

# minimal required versions
set (QT_MIN_VERSION "4.6.0")
set (CMAKE_MIN_VERSION "2.6.0")

# configuration
option (ENABLE_AUTODOWNLOAD "Use automatic download of modules/icons/emoticons" ON)
option (SIG_HANDLING_ENABLED "Define if you want system signals handling" ON)
option (USE_X11_XFIXES "Use X11 Xfixes extension (Desktop Linux)" ON)

if (NOT BUILD_DESCRIPTION)
	set (BUILD_DESCRIPTION "Compiled from sources" CACHE STRING "Build description" FORCE)
endif (NOT BUILD_DESCRIPTION)

if (NOT CMAKE_BUILD_TYPE)
	set (CMAKE_BUILD_TYPE Debug CACHE STRING "Choose the type of build, options are: Debug Release RelWithDebInfo." FORCE)
endif (NOT CMAKE_BUILD_TYPE)

string (REPLACE "-O3" "-O2" CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE}")
string (REPLACE "-O3" "-O2" CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE}")

# build version string if cmake < 2.6.3
if (NOT DEFINED CMAKE_VERSION)
	set (CMAKE_VERSION "${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION}.${CMAKE_PATCH_VERSION}")
endif (NOT DEFINED CMAKE_VERSION)

cmake_minimum_required (VERSION ${CMAKE_MIN_VERSION} FATAL_ERROR)

if (COMMAND cmake_policy)
	cmake_policy (SET CMP0003 NEW)

	if (${CMAKE_VERSION} VERSION_GREATER 2.8.0)
		cmake_policy (SET CMP0015 OLD)
	endif (${CMAKE_VERSION} VERSION_GREATER 2.8.0)
endif (COMMAND cmake_policy)

include (FindPkgConfig)
include (CheckIncludeFiles)
include (CheckFunctionExists)

if (NOT KADU_VERSION)
	find_program (GIT_EXECUTABLE git DOC "git command line client")
	if (GIT_EXECUTABLE)
		execute_process (COMMAND ${GIT_EXECUTABLE} describe --tags HEAD
			WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
			OUTPUT_VARIABLE KADU_VERSION
			OUTPUT_STRIP_TRAILING_WHITESPACE
		)
	endif (GIT_EXECUTABLE)

	if (NOT KADU_VERSION)
		file (READ ${CMAKE_CURRENT_SOURCE_DIR}/VERSION KADU_VERSION)
		string (REPLACE "\n" "" KADU_VERSION ${KADU_VERSION})
	endif (NOT KADU_VERSION)
endif (NOT KADU_VERSION)

if (WIN32)
	# Add more version info to files
	string (REGEX REPLACE "(.+)\\.(.+)\\.(.+)[.-].*" "\\1, \\2, \\3, 0" NUMERIC_VERSION ${KADU_VERSION})
	set (PACKAGE_VERSION ${KADU_VERSION})

	# package
	set (CPACK_GENERATOR "ZIP")
	set (CPACK_PACKAGE_VERSION ${PACKAGE_VERSION})
	include (CPack)
endif (WIN32)

if (NOT WIN32)
	# TODO: Add libexecinfo support
	check_include_files ("execinfo.h" HAVE_EXECINFO)
	if (HAVE_EXECINFO)
		check_function_exists ("backtrace" HAVE_EXECINFO)
	endif (HAVE_EXECINFO)

	if (SIG_HANDLING_ENABLED)
		set (SIG_HANDLING_ENABLED 1)
	endif (SIG_HANDLING_ENABLED)
endif (NOT WIN32)

if (CMAKE_BUILD_TYPE STREQUAL "Debug" OR WIN32)
	add_definitions (-DDEBUG_ENABLED)

	set (DEBUG 1)
	set (DEBUG_ENABLED 1)
endif (CMAKE_BUILD_TYPE STREQUAL "Debug" OR WIN32)

if (MSVC)
	add_definitions (/D_CRT_SECURE_NO_WARNINGS=1)
endif (MSVC)

if (MINGW)
	# override cmake bug/feature?
	set (CMAKE_SHARED_LIBRARY_PREFIX "")
endif (MINGW)

# warnings
if (UNIX AND NOT APPLE)
	set (CMAKE_C_FLAGS "-W -Wall -Werror ${CMAKE_C_FLAGS}")
	set (CMAKE_CXX_FLAGS "-W -Wall -Werror ${CMAKE_CXX_FLAGS}")
elseif (APPLE)
	set (CMAKE_C_FLAGS "-W -Wall ${CMAKE_C_FLAGS}")
	set (CMAKE_CXX_FLAGS "-W -Wall ${CMAKE_CXX_FLAGS}")
elseif (MINGW)
	set (CMAKE_C_FLAGS "-ffast-math -mtune=i686")
	set (CMAKE_CXX_FLAGS "-ffast-math -mtune=i686")
endif (UNIX AND NOT APPLE)

if (NOT KADU_DATADIR)
	set (KADU_DATADIR ${CMAKE_INSTALL_PREFIX}/share)
endif (NOT KADU_DATADIR)
if (NOT KADU_LIBDIR)
	set (KADU_LIBDIR ${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX})
endif (NOT KADU_LIBDIR)
if (NOT KADU_BINDIR)
	set (KADU_BINDIR ${CMAKE_INSTALL_PREFIX}/bin)
endif (NOT KADU_BINDIR)

if (WIN32)
	set (KADU_DATA_DIR ".")
	set (KADU_MODULES_LIBDIR "modules")
	set (KADU_BIN_DIR ".")
else (WIN32)
	set (KADU_DATA_DIR "share/kadu")
	set (KADU_MODULES_LIBDIR lib${LIB_SUFFIX}/kadu/modules)
	set (KADU_BIN_DIR "bin")
endif (WIN32)

set (KADU_MODULES_DIR ${KADU_DATA_DIR}/modules)

# macros
macro (kadu_configuration)
	install (FILES ${ARGN}
		DESTINATION ${KADU_DATA_DIR}/configuration
	)
endmacro (kadu_configuration)

macro (kadu_module_configuration)
	install (FILES ${ARGN}
		DESTINATION ${KADU_MODULES_DIR}/configuration
	)
endmacro (kadu_module_configuration)

macro (kadu_module_desc MODULE_DESC)
	install (FILES ${ARGN}
		DESTINATION ${KADU_MODULES_DIR}
	)
endmacro (kadu_module_desc)

macro (kadu_module)
	set (VARIABLE_NAME "MODULE_NAME")

	set (MODULE_NAME "")
	set (MODULE_SOURCES "")
	set (MODULE_MOC_SOURCES "")
	set (MODULE_TRANSLATION_SOURCES "")
	set (MODULE_CONFIGURATION_FILES "")
	set (MODULE_DATA_FILES "")
	set (MODULE_DATA_DIRECTORY "")
	set (MODULE_BUILDDEF "")
	set (MODULE_DEPENDENCIES "")
	set (MODULE_LIBRARIES "")

	include_directories (".")

	foreach (ARG ${ARGV})
		if ("${VARIABLE_NAME}" STREQUAL "MODULE_NAME")
			set (MODULE_NAME ${ARG})
			set (VARIABLE_NAME "")
		elseif (ARG MATCHES "(MODULE_SOURCES|MODULE_MOC_SOURCES|MODULE_TRANSLATION_SOURCES|MODULE_CONFIGURATION_FILES|MODULE_DATA_FILES|MODULE_DATA_DIRECTORY|MODULE_BUILDDEF|MODULE_DEPENDENCIES|MODULE_LIBRARIES)")
			set (VARIABLE_NAME ${ARG})
		elseif (VARIABLE_NAME STREQUAL "")
			message (FATAL_ERROR "Invalid invocation of kadu_module macro")
		else ("${VARIABLE_NAME}" STREQUAL "MODULE_NAME")
			set (${VARIABLE_NAME} "${${VARIABLE_NAME}};${ARG}")
		endif ("${VARIABLE_NAME}" STREQUAL "MODULE_NAME")
	endforeach (ARG)

	if (WIN32)
		include_directories (${CMAKE_SOURCE_DIR}/modules)

		# opisy .desc sa w iso-8859-2
		set (CMAKE_RC_FLAGS "-c 28592")
		# wygeneruj plik z wersja modulu
		if (${${MODULE_NAME}} STREQUAL SHARED)
			set (MODULE_SOURCES ${MODULE_SOURCES} ${MODULE_NAME}.rc)
			add_custom_command (OUTPUT ${MODULE_NAME}.rc
				COMMAND ${CMAKE_SOURCE_DIR}/modules/modver.bat ARGS ${CMAKE_CURRENT_SOURCE_DIR}/${MODULE_NAME}.desc ${MODULE_NAME}.rc
				WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
				DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/${MODULE_NAME}.desc
				COMMENT "Building RC source ${MODULE_NAME}.rc"
			)
		endif (${${MODULE_NAME}} STREQUAL SHARED)

		# naglowki do SDK
		install (DIRECTORY "." DESTINATION ${KADU_DATA_DIR}/kadu-sdk/include/kadu-modules/${MODULE_NAME} FILES_MATCHING PATTERN "*.h" PATTERN ".svn" EXCLUDE)
	endif (WIN32)

	install (FILES ${MODULE_NAME}.desc
		DESTINATION ${KADU_MODULES_DIR}
	)

	if (MODULE_MOC_SOURCES)
		qt_wrap_cpp (${MODULE_NAME} MODULE_MOC_FILES ${MODULE_MOC_SOURCES})
	endif (MODULE_MOC_SOURCES)

	if (MODULE_TRANSLATION_SOURCES)
		qt4_add_translation (MODULE_TRANSLATION_FILES ${MODULE_TRANSLATION_SOURCES})
	endif (MODULE_TRANSLATION_SOURCES)

	kadu_module_configuration (${MODULE_CONFIGURATION_FILES})

	install (FILES ${MODULE_TRANSLATION_FILES}
		DESTINATION ${KADU_MODULES_DIR}/translations
	)

	if (NOT "${MODULE_DATA_FILES}" STREQUAL "")
		install (FILES ${MODULE_DATA_FILES}
			DESTINATION ${KADU_MODULES_DIR}/data/${MODULE_NAME}
		)
	endif (NOT "${MODULE_DATA_FILES}" STREQUAL "")

	if (NOT "${MODULE_DATA_DIRECTORY}" STREQUAL "")
		install (DIRECTORY ${MODULE_DATA_DIRECTORY}
			DESTINATION ${KADU_MODULES_DIR}/data/${MODULE_NAME}
		)
	endif (NOT "${MODULE_DATA_DIRECTORY}" STREQUAL "")

	add_library (${MODULE_NAME} ${${MODULE_NAME}} ${MODULE_SOURCES} ${MODULE_MOC_FILES})
	add_custom_target (${MODULE_NAME}-translations DEPENDS ${MODULE_TRANSLATION_FILES})

	add_dependencies (${MODULE_NAME} ${MODULE_NAME}-translations)

	if (NOT ${MODULE_BUILDDEF} STREQUAL "")
		set_target_properties (${MODULE_NAME} PROPERTIES COMPILE_DEFINITIONS ${MODULE_BUILDDEF})
	endif (NOT ${MODULE_BUILDDEF} STREQUAL "")

	if (NOT "${MODULE_LIBRARIES}" STREQUAL "")
		target_link_libraries (${MODULE_NAME} ${MODULE_LIBRARIES})
	endif (NOT "${MODULE_LIBRARIES}" STREQUAL "")

	if (${${MODULE_NAME}} STREQUAL STATIC)
		set_target_properties (${MODULE_NAME} PROPERTIES COMPILE_FLAGS "-DKADULIB")
	else (${${MODULE_NAME}} STREQUAL STATIC)
		if (WIN32)
			target_link_libraries (${MODULE_NAME} kadu_core ${MODULE_DEPENDENCIES} ${QT_LIBRARIES})
			install (TARGETS ${MODULE_NAME} ARCHIVE DESTINATION ${KADU_DATA_DIR}/kadu-sdk/lib)
		endif (WIN32)
		if (APPLE)
			set_target_properties (${MODULE_NAME} PROPERTIES LINK_FLAGS "-undefined dynamic_lookup")
		endif (APPLE)
		install (TARGETS ${MODULE_NAME} RUNTIME DESTINATION ${KADU_MODULES_LIBDIR} LIBRARY DESTINATION ${KADU_MODULES_LIBDIR})
	endif (${${MODULE_NAME}} STREQUAL STATIC)
endmacro (kadu_module)

# libraries
find_package (Qt4 REQUIRED)
set (QT_USE_QTXML 1)
set (QT_USE_QTNETWORK 1)
set (QT_USE_QTWEBKIT 1)
set (QT_USE_QTSVG 1)
if (UNIX AND NOT APPLE)
	set (QT_USE_QTDBUS 1)
endif (UNIX AND NOT APPLE)
include (${QT_USE_FILE})
include_directories (${CMAKE_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/kadu-core ${QT_INCLUDES})

# build
configure_file (${CMAKE_SOURCE_DIR}/kadu-config.h.cmake ${CMAKE_BINARY_DIR}/kadu-config.h)

configure_file (${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake IMMEDIATE @ONLY)

add_custom_target (uninstall "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

add_subdirectory (modules)
add_subdirectory (kadu-core)
add_subdirectory (varia)
add_subdirectory (translations)
add_subdirectory (kthxbye)

message (STATUS "Kadu (version: ${KADU_VERSION}) will be build:")
message (STATUS " * install prefix: ${CMAKE_INSTALL_PREFIX}")
message (STATUS " * build type: ${CMAKE_BUILD_TYPE}")

# install data files
install (FILES AUTHORS HISTORY README THANKS ChangeLog ChangeLog.OLD-PL COPYING DESTINATION ${KADU_DATA_DIR})

=== anonymous_check/CMakeLists.txt ===
set (SOURCES
	anonymous_check.cpp
        anonymous_check-module.cpp
        anonymous_info.cpp
)

set (MOC_SOURCES
	anonymous_check.h
)

set (TRANSLATION_SOURCES
	translations/anonymous_check.ts
)

kadu_module (anonymous_check
	MODULE_SOURCES ${SOURCES}
	MODULE_MOC_SOURCES ${MOC_SOURCES}
	MODULE_TRANSLATION_SOURCES ${TRANSLATION_SOURCES}
)

=== globalhotkeys/CMakeLists.txt ===
set( SOURCES
	globalhotkeys.cpp
	api.cpp
	buddiesmenu.cpp
	conf.cpp
	functions.cpp
	globalmenu.cpp
	globalwidgetmanager.cpp
	hotkey.cpp
	hotkeyedit.cpp
	serializableqstringlist.cpp
	statusesmenu.cpp
	wideiconsmenu.cpp
)

set( MOC_SOURCES
	globalhotkeys.h
	buddiesmenu.h
	conf.h
	functions.h
	globalmenu.h
	globalwidgetmanager.h
	statusesmenu.h
)

set( TRANSLATION_SOURCES
	translations/globalhotkeys_en.ts
	translations/globalhotkeys_pl.ts
)

set( CONFIGURATION_FILES
	configuration/globalhotkeys.ui
)

kadu_module( globalhotkeys
	MODULE_SOURCES ${SOURCES}
	MODULE_MOC_SOURCES ${MOC_SOURCES}
	MODULE_TRANSLATION_SOURCES ${TRANSLATION_SOURCES}
	MODULE_CONFIGURATION_FILES ${CONFIGURATION_FILES}
)

=== kadu-core/CMakeLists.txt ===
set (kadu_SRCS
	accounts/account.cpp
	accounts/account-details.cpp
	accounts/account-manager.cpp
	accounts/account-proxy-settings.cpp
	accounts/account-shared.cpp
	accounts/accounts-aware-object.cpp

	accounts/filter/have-multilogon-filter.cpp
	accounts/filter/id-validity-filter.cpp
	accounts/filter/protocol-filter.cpp
	accounts/filter/writeable-contacts-list-filter.cpp

	accounts/model/accounts-model.cpp
	accounts/model/accounts-proxy-model.cpp

	avatars/avatar.cpp
	avatars/avatar-job-manager.cpp
	avatars/avatar-job-runner.cpp
	avatars/avatar-manager.cpp
	avatars/avatar-shared.cpp

	buddies/buddies-aware-object.cpp
	buddies/buddy.cpp
	buddies/buddy-additional-data-delete-handler.cpp
	buddies/buddy-additional-data-delete-handler-manager.cpp
	buddies/buddy-kadu-data.cpp
	buddies/buddy-list.cpp
	buddies/buddy-list-mime-data-helper.cpp
	buddies/buddy-manager.cpp
	buddies/buddy-or-contact.cpp
	buddies/buddy-preferred-manager.cpp
	buddies/buddy-remove-predicate-object.cpp
	buddies/buddy-search-criteria.cpp
	buddies/buddy-set.cpp
	buddies/buddy-shared.cpp
	buddies/group.cpp
	buddies/group-manager.cpp
	buddies/group-shared.cpp

	buddies/filter/account-buddy-filter.cpp
	buddies/filter/anonymous-buddy-filter.cpp
	buddies/filter/anonymous-without-messages-buddy-filter.cpp
	buddies/filter/blocked-buddy-filter.cpp
	buddies/filter/buddy-name-filter.cpp
	buddies/filter/group-buddy-filter.cpp
	buddies/filter/has-description-buddy-filter.cpp
	buddies/filter/mobile-buddy-filter.cpp
	buddies/filter/non-buddy-filter.cpp
	buddies/filter/offline-buddy-filter.cpp
	buddies/filter/online-and-description-buddy-filter.cpp
	buddies/filter/pending-messages-filter.cpp

	buddies/model/abstract-buddies-model.cpp
	buddies/model/buddy-data-extractor.cpp
	buddies/model/buddy-list-model.cpp
	buddies/model/buddies-model.cpp
	buddies/model/buddies-model-base.cpp
	buddies/model/buddies-model-proxy.cpp
	buddies/model/groups-model.cpp

	chat/aggregate-chat-manager.cpp
	chat/chat.cpp
	chat/chat-details-aggregate.cpp
	chat/chat-details-conference.cpp
	chat/chat-details-simple.cpp
	chat/chat-geometry-data.cpp
	chat/chat-manager.cpp
	chat/chat-shared.cpp
	chat/chat-styles-manager.cpp
	chat/html-messages-renderer.cpp
	chat/recent-chat-manager.cpp

	chat/filter/chat-name-filter.cpp

	chat/message/formatted-message.cpp
	chat/message/formatted-message-part.cpp
	chat/message/message.cpp
	chat/message/message-render-info.cpp
	chat/message/pending-messages-manager.cpp
	chat/message/message-shared.cpp

	chat/style-engines/chat-engine-adium/adium-style.cpp
	chat/style-engines/chat-engine-adium/adium-time-formatter.cpp
	chat/style-engines/chat-engine-adium/chat-engine-adium.cpp
	chat/style-engines/chat-engine-kadu/chat-engine-kadu.cpp

	chat/type/chat-type.cpp
	chat/type/chat-type-aware-object.cpp
	chat/type/chat-type-conference.cpp
	chat/type/chat-type-manager.cpp
	chat/type/chat-type-simple.cpp

	configuration/config-file-data-manager.cpp
	configuration/configuration-aware-object.cpp
	configuration/configuration-file.cpp
	configuration/configuration-manager.cpp
	configuration/main-configuration.cpp
	configuration/notifier-configuration-data-manager.cpp
	configuration/toolbar-configuration-manager.cpp
	configuration/xml-configuration-file.cpp

	contacts/contact.cpp
	contacts/contact-details.cpp
	contacts/contact-manager.cpp
	contacts/contact-parser-tags.cpp
	contacts/contact-set.cpp
	contacts/contact-set-configuration-helper.cpp
	contacts/contact-shared.cpp

	contacts/filter/contact-no-unloaded-account-filter.cpp

	contacts/model/buddy-contact-model.cpp
	contacts/model/contact-data-extractor.cpp
	contacts/model/contact-list-model.cpp

	core/core.cpp
	core/core-actions.cpp
	core/crash-aware-object.cpp

	emoticons/emoticon-selector-button.cpp
	emoticons/emoticon-selector.cpp
	emoticons/emoticons-manager.cpp
	emoticons/emots-walker.cpp
	emoticons/prefix-node.cpp

	gui/hot-key.cpp

	gui/actions/action.cpp
	gui/actions/actions.cpp
	gui/actions/action-description.cpp

	gui/widgets/account-buddy-list-widget.cpp
	gui/widgets/account-avatar-widget.cpp
	gui/widgets/accounts-combo-box.cpp
	gui/widgets/buddies-list-view.cpp
	gui/widgets/buddies-list-view-avatar-painter.cpp
	gui/widgets/buddies-list-view-delegate.cpp
	gui/widgets/buddies-list-view-delegate-configuration.cpp
	gui/widgets/buddies-list-view-item-painter.cpp
	gui/widgets/buddies-list-view-menu-item.cpp
	gui/widgets/buddies-list-view-menu-manager.cpp
	gui/widgets/buddies-list-widget.cpp
	gui/widgets/buddy-avatar-widget.cpp
	gui/widgets/buddy-contacts-table-delegate.cpp
	gui/widgets/buddy-contacts-table-item.cpp
	gui/widgets/buddy-contacts-table-model.cpp
	gui/widgets/buddy-contacts-table-model-proxy.cpp
	gui/widgets/buddy-contacts-table.cpp
	gui/widgets/buddy-general-configuration-widget.cpp
	gui/widgets/buddy-groups-configuration-widget.cpp
	gui/widgets/buddy-personal-info-configuration-widget.cpp
	gui/widgets/buddy-options-configuration-widget.cpp
	gui/widgets/buddy-info-panel.cpp
	gui/widgets/chat-edit-box.cpp
	gui/widgets/chat-edit-box-size-manager.cpp
	gui/widgets/chat-messages-view.cpp
	gui/widgets/chat-view-network-access-manager.cpp
	gui/widgets/chat-widget.cpp
	gui/widgets/chat-widget-actions.cpp
	gui/widgets/chat-widget-manager.cpp
	gui/widgets/choose-identity-widget.cpp
	gui/widgets/color-button.cpp
	gui/widgets/color-selector.cpp
	gui/widgets/custom-input.cpp
	gui/widgets/delayed-line-edit.cpp
	gui/widgets/filter-widget.cpp
	gui/widgets/group-tab-bar.cpp
	gui/widgets/groups-combo-box.cpp
	gui/widgets/identities-combo-box.cpp
	gui/widgets/kadu-web-view.cpp
	gui/widgets/line-edit-clear-button.cpp
	gui/widgets/line-edit-with-clear-button.cpp
	gui/widgets/modal-configuration-widget.cpp
	gui/widgets/path-edit.cpp
	gui/widgets/path-list-edit.cpp
	gui/widgets/progress-icon.cpp
	gui/widgets/progress-label.cpp
	gui/widgets/protocols-combo-box.cpp
	gui/widgets/proxy-group-box.cpp
	gui/widgets/preview.cpp
	gui/widgets/select-buddy-combo-box.cpp
	gui/widgets/select-buddy-popup.cpp
	gui/widgets/select-file.cpp
	gui/widgets/select-font.cpp
	gui/widgets/status-button.cpp
	gui/widgets/status-buttons.cpp
	gui/widgets/status-menu.cpp
	gui/widgets/syntax-editor.cpp
	gui/widgets/toolbar.cpp
	gui/widgets/tool-tip-class-manager.cpp

	gui/widgets/configuration/buddy-list-background-colors-widget.cpp
	gui/widgets/configuration/config-action-button.cpp
	gui/widgets/configuration/config-check-box.cpp
	gui/widgets/configuration/config-color-button.cpp
	gui/widgets/configuration/config-combo-box.cpp
	gui/widgets/configuration/config-gg-password-edit.cpp
	gui/widgets/configuration/config-hot-key-edit.cpp
	gui/widgets/configuration/config-label.cpp
	gui/widgets/configuration/config-line-separator.cpp
	gui/widgets/configuration/config-line-edit.cpp
	gui/widgets/configuration/config-list-widget.cpp
	gui/widgets/configuration/config-path-list-edit.cpp
	gui/widgets/configuration/config-preview.cpp
	gui/widgets/configuration/config-radio-button.cpp
	gui/widgets/configuration/config-select-file.cpp
	gui/widgets/configuration/config-select-font.cpp
	gui/widgets/configuration/config-slider.cpp
	gui/widgets/configuration/config-spin-box.cpp
	gui/widgets/configuration/config-syntax-editor.cpp
	gui/widgets/configuration/config-widget-value.cpp
	gui/widgets/configuration/config-widget.cpp
	gui/widgets/configuration/configuration-widget.cpp
	gui/widgets/configuration/config-section.cpp
	gui/widgets/configuration/config-group-box.cpp
	gui/widgets/configuration/config-tab.cpp
	gui/widgets/configuration/notifier-configuration-widget.cpp
	gui/widgets/configuration/notify-group-box.cpp
	gui/widgets/configuration/notify-tree-widget.cpp

	gui/windows/about.cpp
	gui/windows/add-buddy-window.cpp
	gui/windows/buddy-data-window.cpp
	gui/windows/buddy-data-window-aware-object.cpp
	gui/windows/buddy-delete-window.cpp
	gui/windows/chat-window.cpp
	gui/windows/choose-description.cpp
	gui/windows/configuration-window.cpp
	gui/windows/group-properties-window.cpp
	gui/windows/kadu-window.cpp
	gui/windows/kadu-window-actions.cpp
	gui/windows/main-configuration-window.cpp
	gui/windows/main-window.cpp
	gui/windows/merge-buddies-window.cpp
	gui/windows/message-dialog.cpp
	gui/windows/modules-window.cpp
	gui/windows/multilogon-window.cpp
	gui/windows/password-window.cpp
	gui/windows/progress-window.cpp
	gui/windows/search-window.cpp
	gui/windows/search-window-actions.cpp
	gui/windows/subscription-window.cpp
	gui/windows/syntax-editor-window.cpp
	gui/windows/updates-dialog.cpp
	gui/windows/window-notifier-window.cpp
	gui/windows/your-accounts.cpp

	gui/windows/open-chat-with/open-chat-with.cpp
	gui/windows/open-chat-with/open-chat-with-contact-list-runner.cpp
	gui/windows/open-chat-with/open-chat-with-runner-manager.cpp

	identities/model/identity-model.cpp
	identities/identities-aware-object.cpp
	identities/identity.cpp
	identities/identity-manager.cpp
	identities/identity-shared.cpp

	misc/coding-conversion.cpp
	misc/date-time.cpp
	misc/misc.cpp
	misc/path-conversion.cpp
	misc/syntax-list.cpp

	model/actions-proxy-model.cpp

	multilogon/model/multilogon-model.cpp

	multilogon/multilogon-session.cpp

	notify/account-notification.cpp
	notify/buddy-notify-data.cpp
	notify/chat-notification.cpp
	notify/new-message-notification.cpp
	notify/multilogon-notification.cpp
	notify/notification.cpp
	notify/notification-manager.cpp
	notify/notifier.cpp
	notify/notify-configuration-ui-handler.cpp
	notify/notify-event.cpp
	notify/status-changed-notification.cpp
	notify/window-notifier.cpp

	os/generic/compositing-aware-object.cpp
	os/generic/system-info.cpp
	os/generic/url-opener.cpp

	parser/parser.cpp

	protocols/connection-error-notification.cpp
	protocols/protocol.cpp
	protocols/protocols-aware-object.cpp
	protocols/protocols-manager.cpp
	protocols/filter/can-register-protocol-filter.cpp
	protocols/model/protocols-model.cpp
	protocols/model/protocols-model-proxy.cpp
	protocols/services/chat-service.cpp
	protocols/services/chat-image-service.cpp
	protocols/services/contact-list-service.cpp

	qt/long-validator.cpp

	status/base-status-container.cpp
	status/description-manager.cpp
	status/description-model.cpp
	status/status.cpp
	status/status-actions.cpp
	status/status-changer.cpp
	status/status-changer-manager.cpp
	status/status-container-aware-object.cpp
	status/status-container-manager.cpp
	status/status-group.cpp
	status/status-group-manager.cpp
	status/status-type.cpp
	status/status-type-manager.cpp

	storage/named-storable-object.cpp
	storage/module-data.cpp
	storage/shared.cpp
	storage/shared-base.cpp
	storage/storable-object.cpp
	storage/storable-string-list.cpp
	storage/storage-point.cpp
	storage/uuid-storable-object.cpp

	themes/emoticon-theme-manager.cpp
	themes/icon-theme-manager.cpp
	themes/theme.cpp
	themes/theme-manager.cpp

	url-handlers/mail-url-handler.cpp
	url-handlers/standard-url-handler.cpp
	url-handlers/url-handler-manager.cpp

	activate.cpp
	debug.cpp
	dnshandler.cpp
	html_document.cpp
	icons-manager.cpp
	kadu-application.cpp
	languages-manager.cpp
	modules.cpp
	themes.cpp
	updates.cpp
)

if (UNIX AND NOT APPLE)
	set (kadu_SRCS
		${kadu_SRCS}
		os/x11tools.cpp
	)
endif (UNIX AND NOT APPLE)
if (NOT WIN32)
	set (kadu_SRCS
		${kadu_SRCS}
		os/qtsingleapplication/qtlocalpeer.cpp
		os/qtsingleapplication/qtlockedfile.cpp
	)
endif (NOT WIN32)

set (kadu_MOC_SRCS
	accounts/account-manager.h
	accounts/account-shared.h

	accounts/filter/abstract-account-filter.h
	accounts/filter/have-multilogon-filter.h
	accounts/filter/id-validity-filter.h
	accounts/filter/protocol-filter.h
	accounts/filter/writeable-contacts-list-filter.h

	accounts/model/accounts-model.h
	accounts/model/accounts-proxy-model.h

	avatars/avatar-job-manager.h
	avatars/avatar-job-runner.h
	avatars/avatar-manager.h
	avatars/avatar-shared.h

	buddies/buddy-additional-data-delete-handler-manager.h
	buddies/buddy-kadu-data.h
	buddies/buddy-shared.h
	buddies/buddy-manager.h
	buddies/group-manager.h
	buddies/buddy-preferred-manager.h
	buddies/group-shared.h

=== lednotify/CMakeLists.txt ===
set( SOURCES
	ledblinker.cpp
	lednotify.cpp
)

set( MOC_SOURCES
	ledblinker.h
	lednotify.h
)

if( WIN32 )
	list( APPEND SOURCES leddriver_win32.cpp ../module.rc )
	include_directories( ${CMAKE_CURRENT_SOURCE_DIR} )
else( WIN32 )
	list( APPEND SOURCES leddriver_x11.cpp )
endif( WIN32 )


set( TRANSLATION_SOURCES
	translations/lednotify_en.ts
	translations/lednotify_pl.ts
)


set( CONFIGURATION_FILES
	configuration/lednotify.ui
)


kadu_module( lednotify
	MODULE_SOURCES ${SOURCES}
	MODULE_MOC_SOURCES ${MOC_SOURCES}
	MODULE_TRANSLATION_SOURCES ${TRANSLATION_SOURCES}
	MODULE_CONFIGURATION_FILES ${CONFIGURATION_FILES}
)

=== mime_tex/CMakeLists.txt ===
add_subdirectory (mimetex)
set (SOURCES
	formula_view.cpp
	formula_widget.cpp
	mime_tex.cpp
	tex_formula_dialog.cpp
)

set (MOC_SOURCES
	formula_view.h
	formula_widget.h
	mime_tex.h
	tex_formula_dialog.h
)

set (TRANSLATION_SOURCES
	translations/mime_tex_pl.ts
)

set (CONFIGURATION_FILES
	configuration/mime_tex.ui)

set (DATA_FILES
	data/mime_tex_32x32.png
)
set (DATA_FILES_EDITOR_ICONS
	data/editor_icons/redo.png
	data/editor_icons/undo.png
)
set (DATA_FILES_MIME_TEX_ICONS
	data/mime_tex_icons/arrows_tab_Downarrow.png
	data/mime_tex_icons/arrows_tab_icon.png
	data/mime_tex_icons/arrows_tab_leftarrow.png
	data/mime_tex_icons/arrows_tab_Leftarrow.png
	data/mime_tex_icons/arrows_tab_leftharpoondown.png
	data/mime_tex_icons/arrows_tab_leftharpoonup.png
	data/mime_tex_icons/arrows_tab_leftrightarrow.png
	data/mime_tex_icons/arrows_tab_Leftrightarrow.png
	data/mime_tex_icons/arrows_tab_longleftarrow.png
	data/mime_tex_icons/arrows_tab_Longleftarrow.png
	data/mime_tex_icons/arrows_tab_longleftrightarrow.png
	data/mime_tex_icons/arrows_tab_Longleftrightarrow.png
	data/mime_tex_icons/arrows_tab_longrightarrow.png
	data/mime_tex_icons/arrows_tab_Longrightarrow.png
	data/mime_tex_icons/arrows_tab_nearrow.png
	data/mime_tex_icons/arrows_tab_nwarrow.png
	data/mime_tex_icons/arrows_tab_rightarrow.png
	data/mime_tex_icons/arrows_tab_Rightarrow.png
	data/mime_tex_icons/arrows_tab_rightharpoondown.png
	data/mime_tex_icons/arrows_tab_rightharpoonup.png
	data/mime_tex_icons/arrows_tab_rightleftharpoons.png
	data/mime_tex_icons/arrows_tab_searrow.png
	data/mime_tex_icons/arrows_tab_swarrow.png
	data/mime_tex_icons/arrows_tab_uparrow.png
	data/mime_tex_icons/arrows_tab_Uparrow.png
	data/mime_tex_icons/arrows_tab_updownarrow.png
	data/mime_tex_icons/arrows_tab_Updownarrow.png
	data/mime_tex_icons/arrows_tab_vec.png
	data/mime_tex_icons/delimiters_tab_hat.png
	data/mime_tex_icons/delimiters_tab_icon.png
	data/mime_tex_icons/delimiters_tab_langle.png
	data/mime_tex_icons/delimiters_tab_lbrace.png
	data/mime_tex_icons/delimiters_tab_left_bracket.png
	data/mime_tex_icons/delimiters_tab_left_lbrace.png
	data/mime_tex_icons/delimiters_tab_left_square_bracket.png
	data/mime_tex_icons/delimiters_tab_overbrace_desc.png
	data/mime_tex_icons/delimiters_tab_overbrace.png
	data/mime_tex_icons/delimiters_tab_overline.png
	data/mime_tex_icons/delimiters_tab_rangle.png
	data/mime_tex_icons/delimiters_tab_rbrace.png
	data/mime_tex_icons/delimiters_tab_right_bracket.png
	data/mime_tex_icons/delimiters_tab_right_rbrace.png
	data/mime_tex_icons/delimiters_tab_right_square_bracket.png
	data/mime_tex_icons/delimiters_tab_underbrace_desc.png
	data/mime_tex_icons/delimiters_tab_underbrace.png
	data/mime_tex_icons/delimiters_tab_underline.png
	data/mime_tex_icons/greek_letters_tab_alpha.png
	data/mime_tex_icons/greek_letters_tab_beta.png
	data/mime_tex_icons/greek_letters_tab_chi.png
	data/mime_tex_icons/greek_letters_tab_delta.png
	data/mime_tex_icons/greek_letters_tab_Delta.png
	data/mime_tex_icons/greek_letters_tab_epsilon.png
	data/mime_tex_icons/greek_letters_tab_eta.png
	data/mime_tex_icons/greek_letters_tab_gamma.png
	data/mime_tex_icons/greek_letters_tab_Gamma.png
	data/mime_tex_icons/greek_letters_tab_icon.png
	data/mime_tex_icons/greek_letters_tab_iota.png
	data/mime_tex_icons/greek_letters_tab_kappa.png
	data/mime_tex_icons/greek_letters_tab_lambda.png
	data/mime_tex_icons/greek_letters_tab_Lambda.png
	data/mime_tex_icons/greek_letters_tab_mu.png
	data/mime_tex_icons/greek_letters_tab_nu.png
	data/mime_tex_icons/greek_letters_tab_omega.png
	data/mime_tex_icons/greek_letters_tab_Omega.png
	data/mime_tex_icons/greek_letters_tab_phi.png
	data/mime_tex_icons/greek_letters_tab_Phi.png
	data/mime_tex_icons/greek_letters_tab_pi.png
	data/mime_tex_icons/greek_letters_tab_Pi.png
	data/mime_tex_icons/greek_letters_tab_psi.png
	data/mime_tex_icons/greek_letters_tab_Psi.png
	data/mime_tex_icons/greek_letters_tab_rho.png
	data/mime_tex_icons/greek_letters_tab_sigma.png
	data/mime_tex_icons/greek_letters_tab_Sigma.png
	data/mime_tex_icons/greek_letters_tab_tau.png
	data/mime_tex_icons/greek_letters_tab_theta.png
	data/mime_tex_icons/greek_letters_tab_Theta.png
	data/mime_tex_icons/greek_letters_tab_upsilon.png
	data/mime_tex_icons/greek_letters_tab_Upsilon.png
	data/mime_tex_icons/greek_letters_tab_varepsilon.png
	data/mime_tex_icons/greek_letters_tab_varphi.png
	data/mime_tex_icons/greek_letters_tab_varpi.png
	data/mime_tex_icons/greek_letters_tab_varrho.png
	data/mime_tex_icons/greek_letters_tab_varsigma.png
	data/mime_tex_icons/greek_letters_tab_vartheta.png
	data/mime_tex_icons/greek_letters_tab_xi.png
	data/mime_tex_icons/greek_letters_tab_Xi.png
	data/mime_tex_icons/greek_letters_tab_zeta.png
	data/mime_tex_icons/relations_tab_approx.png
	data/mime_tex_icons/relations_tab_bigcap.png
	data/mime_tex_icons/relations_tab_bigcup.png
	data/mime_tex_icons/relations_tab_cap.png
	data/mime_tex_icons/relations_tab_cup.png
	data/mime_tex_icons/relations_tab_equiv.png
	data/mime_tex_icons/relations_tab_frac.png
	data/mime_tex_icons/relations_tab_geq.png
	data/mime_tex_icons/relations_tab_gg.png
	data/mime_tex_icons/relations_tab_icon.png
	data/mime_tex_icons/relations_tab_index_lower.png
	data/mime_tex_icons/relations_tab_index_upper.png
	data/mime_tex_icons/relations_tab_in.png
	data/mime_tex_icons/relations_tab_int_from.png
	data/mime_tex_icons/relations_tab_int_from_to.png
	data/mime_tex_icons/relations_tab_int.png
	data/mime_tex_icons/relations_tab_leq.png
	data/mime_tex_icons/relations_tab_lim.png
	data/mime_tex_icons/relations_tab_ll.png
	data/mime_tex_icons/relations_tab_neq.png
	data/mime_tex_icons/relations_tab_ni.png
	data/mime_tex_icons/relations_tab_oint_from.png
	data/mime_tex_icons/relations_tab_oint_from_to.png
	data/mime_tex_icons/relations_tab_oint.png
	data/mime_tex_icons/relations_tab_pm.png
	data/mime_tex_icons/relations_tab_prod_from.png
	data/mime_tex_icons/relations_tab_prod_from_to.png
	data/mime_tex_icons/relations_tab_prod.png
	data/mime_tex_icons/relations_tab_simeq.png
	data/mime_tex_icons/relations_tab_sim.png
	data/mime_tex_icons/relations_tab_sqrt_n.png
	data/mime_tex_icons/relations_tab_sqrt.png
	data/mime_tex_icons/relations_tab_subseteq.png
	data/mime_tex_icons/relations_tab_subset.png
	data/mime_tex_icons/relations_tab_sum_from.png
	data/mime_tex_icons/relations_tab_sum_from_to.png
	data/mime_tex_icons/relations_tab_sum.png
	data/mime_tex_icons/relations_tab_supseteq.png
	data/mime_tex_icons/relations_tab_supset.png
	data/mime_tex_icons/symbols_tab_aleph.png
	data/mime_tex_icons/symbols_tab_angle.png
	data/mime_tex_icons/symbols_tab_bot.png
	data/mime_tex_icons/symbols_tab_cdot.png
	data/mime_tex_icons/symbols_tab_cdots.png
	data/mime_tex_icons/symbols_tab_ddots.png
	data/mime_tex_icons/symbols_tab_emptyset.png
	data/mime_tex_icons/symbols_tab_forall.png
	data/mime_tex_icons/symbols_tab_hbar.png
	data/mime_tex_icons/symbols_tab_icon.png
	data/mime_tex_icons/symbols_tab_Im.png
	data/mime_tex_icons/symbols_tab_infty.png
	data/mime_tex_icons/symbols_tab_ldots.png
	data/mime_tex_icons/symbols_tab_nabla.png
	data/mime_tex_icons/symbols_tab_partial.png
	data/mime_tex_icons/symbols_tab_prime.png
	data/mime_tex_icons/symbols_tab_Re.png
	data/mime_tex_icons/symbols_tab_surd.png
	data/mime_tex_icons/tex_icon.png
)

kadu_module (mime_tex
	MODULE_SOURCES ${SOURCES}
    MODULE_MOC_SOURCES ${MOC_SOURCES}
    MODULE_TRANSLATION_SOURCES ${TRANSLATION_SOURCES}
    MODULE_CONFIGURATION_FILES ${CONFIGURATION_FILES}
)

install (FILES ${DATA_FILES}
	DESTINATION "share/kadu/modules/data/mime_tex")
install (FILES ${DATA_FILES_EDITOR_ICONS}
	DESTINATION "share/kadu/modules/data/mime_tex/editor_icons")
install (FILES ${DATA_FILES_MIME_TEX_ICONS}
	DESTINATION "share/kadu/modules/data/mime_tex/mime_tex_icons")

=== modules/CMakeLists.txt ===
set (BLACKLIST_MODULES
	advanced_userlist
	dbus
	echo
	profiles
	split_messages
	tlen_protocol
	weather
)

if (WIN32)
	exec_program (${CMAKE_CURRENT_SOURCE_DIR}/get-all.bat ${CMAKE_CURRENT_SOURCE_DIR}
		ARGS OFF
		OUTPUT_VARIABLE MODULES
	)

	exec_program (${CMAKE_CURRENT_SOURCE_DIR}/get-list.bat ${CMAKE_CURRENT_SOURCE_DIR}
		ARGS "y" ${MODULES}
		OUTPUT_VARIABLE STATIC_MODULES
	)

	exec_program (${CMAKE_CURRENT_SOURCE_DIR}/get-list.bat ${CMAKE_CURRENT_SOURCE_DIR}
		ARGS "m" ${MODULES}
		OUTPUT_VARIABLE DYNAMIC_MODULES
	)

	exec_program (${CMAKE_CURRENT_SOURCE_DIR}/get-list.bat ${CMAKE_CURRENT_SOURCE_DIR}
		ARGS "n" ${MODULES}
		OUTPUT_VARIABLE DISABLED_MODULES
	)

#	exec_program (${CMAKE_CURRENT_SOURCE_DIR}/check-deps.bat ${CMAKE_CURRENT_SOURCE_DIR}
#		ARGS ${STATIC_MODULES} - ${DYNAMIC_MODULES}
#		OUTPUT_VARIABLE DEPS_MESSAGE
#		RETURN_VALUE DEPS_STATUS
#	)

	if (ENABLE_AUTODOWNLOAD)
		foreach (MODULE ${STATIC_MODULES} ${DYNAMIC_MODULES})
			if (EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/${MODULE}.web)
				if (EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/${MODULE}/.autodownloaded OR NOT EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/${MODULE}/CMakeLists.txt)
					exec_program (${CMAKE_SOURCE_DIR}/varia/scripts/autodownload.bat ${CMAKE_CURRENT_SOURCE_DIR}
						ARGS module ${MODULE}
						RETURN_VALUE DOWNLOAD_STATUS
					)
					if (DOWNLOAD_STATUS EQUAL 1)
						message (FATAL_ERROR ${MODULE} " download failed!")
					endif (DOWNLOAD_STATUS EQUAL 1)
				endif (EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/${MODULE}/.autodownloaded OR NOT EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/${MODULE}/CMakeLists.txt)
			endif (EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/${MODULE}.web)
		endforeach (MODULE)
	endif (ENABLE_AUTODOWNLOAD)

	exec_program (${CMAKE_CURRENT_SOURCE_DIR}/check-deps.sh ${CMAKE_CURRENT_SOURCE_DIR}
		ARGS ${AWK} ${STATIC_MODULES} - ${DYNAMIC_MODULES}
		OUTPUT_VARIABLE DEPS_MESSAGE
		RETURN_VALUE DEPS_STATUS
	)

	if (DEPS_STATUS EQUAL 1)
		message (FATAL_ERROR ${DEPS_MESSAGE})
	endif (DEPS_STATUS EQUAL 1)

	exec_program (${CMAKE_CURRENT_SOURCE_DIR}/create-static-modules.bat ${CMAKE_CURRENT_BINARY_DIR}
		ARGS ${STATIC_MODULES}
		OUTPUT_VARIABLE NULL_VAR
	)
else (WIN32)
	set (STATIC_MODULES "")
	set (STATIC_MODULES ${STATIC_MODULES} CACHE INTERNAL "")

	exec_program (${CMAKE_CURRENT_SOURCE_DIR}/get-all.sh ${CMAKE_CURRENT_SOURCE_DIR}
		ARGS ${ENABLE_AUTODOWNLOAD}
		OUTPUT_VARIABLE MODULES
	)

	exec_program (${CMAKE_CURRENT_SOURCE_DIR}/get-list.sh ${CMAKE_CURRENT_SOURCE_DIR}
		ARGS "y" ${MODULES}
		OUTPUT_VARIABLE STATIC_MODULES
	)

	exec_program (${CMAKE_CURRENT_SOURCE_DIR}/get-list.sh ${CMAKE_CURRENT_SOURCE_DIR}
		ARGS "m" ${MODULES}
		OUTPUT_VARIABLE DYNAMIC_MODULES
	)

	exec_program (${CMAKE_CURRENT_SOURCE_DIR}/get-list.sh ${CMAKE_CURRENT_SOURCE_DIR}
		ARGS "n" ${MODULES}
		OUTPUT_VARIABLE DISABLED_MODULES
	)

	# autodownload
	if (ENABLE_AUTODOWNLOAD)
		foreach (MODULE ${STATIC_MODULES} ${DYNAMIC_MODULES})
			if (EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/${MODULE}.web)
				if (EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/${MODULE}/.autodownloaded OR NOT EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/${MODULE}/CMakeLists.txt)
					exec_program (${CMAKE_SOURCE_DIR}/varia/scripts/autodownload ${CMAKE_CURRENT_SOURCE_DIR}
						ARGS module ${MODULE}
						RETURN_VALUE DOWNLOAD_STATUS
					)
					if (DOWNLOAD_STATUS EQUAL 1)
						message (FATAL_ERROR ${MODULE} " download failed!")
					endif (DOWNLOAD_STATUS EQUAL 1)
				endif (EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/${MODULE}/.autodownloaded OR NOT EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/${MODULE}/CMakeLists.txt)
			endif (EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/${MODULE}.web)
		endforeach (MODULE)
	endif (ENABLE_AUTODOWNLOAD)

	exec_program (${CMAKE_CURRENT_SOURCE_DIR}/check-deps.sh ${CMAKE_CURRENT_SOURCE_DIR}
		ARGS ${AWK} ${STATIC_MODULES} - ${DYNAMIC_MODULES}
		OUTPUT_VARIABLE DEPS_MESSAGE
		RETURN_VALUE DEPS_STATUS
	)

	if (DEPS_STATUS EQUAL 1)
		message (FATAL_ERROR ${DEPS_MESSAGE})
	endif (DEPS_STATUS EQUAL 1)

	exec_program (${CMAKE_CURRENT_SOURCE_DIR}/create-static-modules.sh ${CMAKE_CURRENT_BINARY_DIR}
		ARGS ${STATIC_MODULES}
		OUTPUT_VARIABLE NULL_VAR
	)

	find_program (AWK NAMES awk gawk)
endif (WIN32)

MACRO(LIST_CONTAINS var value)
	SET(${var})
	FOREACH (value2 ${ARGN})
		IF (${value} STREQUAL ${value2})
			SET(${var} TRUE)
		ENDIF (${value} STREQUAL ${value2})
	ENDFOREACH (value2)
ENDMACRO(LIST_CONTAINS)

if (NOT STATIC_MODULES STREQUAL "\n")
	set (STATIC_MODULES ${STATIC_MODULES} CACHE INTERNAL "")

	foreach (MODULE ${STATIC_MODULES})
		LIST_CONTAINS(BLACKLISTED ${MODULE} ${BLACKLIST_MODULES})
		if (BLACKLISTED)
			message (STATUS "Module ${MODULE} is blacklisted")
		else (BLACKLISTED)
			message (STATUS "Static module: " ${MODULE})
			set (${MODULE} STATIC)
			link_directories (${MODULE})
			add_subdirectory (${MODULE})
		endif (BLACKLISTED)
	endforeach (MODULE)
endif (NOT STATIC_MODULES STREQUAL "\n")

if (NOT DYNAMIC_MODULES STREQUAL "\n")
	foreach (MODULE ${DYNAMIC_MODULES})
		LIST_CONTAINS(BLACKLISTED ${MODULE} ${BLACKLIST_MODULES})
		if (BLACKLISTED)
			message (STATUS "Module ${MODULE} is blacklisted")
		else (BLACKLISTED)
			message (STATUS "Dynamic module: " ${MODULE})
			if (WIN32)
				set (${MODULE} SHARED)
			else (WIN32)
				set (${MODULE} MODULE)
			endif (WIN32)
		# 	link_directories (${MODULE})
			add_subdirectory (${MODULE})
		endif (BLACKLISTED)
	endforeach (MODULE)
endif (NOT DYNAMIC_MODULES STREQUAL "\n")

=== nextinfo/CMakeLists.txt ===
set( SOURCES
	nextinfo.cpp
	buddynextinfodata.cpp
	extendedinformationwidgets.cpp
	photowidget.cpp
)

set( MOC_SOURCES
	nextinfo.h
	buddynextinfodata.h
	extendedinformationwidgets.h
	photowidget.h
)

set( TRANSLATION_SOURCES
	translations/nextinfo_en.ts
	translations/nextinfo_pl.ts
)

set( CONFIGURATION_FILES
	configuration/nextinfo.ui
)

set( QT_USE_QTSCRIPT 1 )
include( ${QT_USE_FILE} )

kadu_module( nextinfo
	MODULE_SOURCES ${SOURCES}
	MODULE_MOC_SOURCES ${MOC_SOURCES}
	MODULE_TRANSLATION_SOURCES ${TRANSLATION_SOURCES}
	MODULE_CONFIGURATION_FILES ${CONFIGURATION_FILES}
)

target_link_libraries( nextinfo ${QT_QTSCRIPT_LIBRARY} )

=== senthistory/CMakeLists.txt ===
set( SOURCES
	senthistory.cpp
)

set( MOC_SOURCES
	senthistory.h
)

set( TRANSLATION_SOURCES
	translations/senthistory_en.ts
	translations/senthistory_pl.ts
)

set( CONFIGURATION_FILES
	configuration/senthistory.ui
)

kadu_module( senthistory
	MODULE_SOURCES ${SOURCES}
	MODULE_MOC_SOURCES ${MOC_SOURCES}
	MODULE_TRANSLATION_SOURCES ${TRANSLATION_SOURCES}
	MODULE_CONFIGURATION_FILES ${CONFIGURATION_FILES}
)

=== translations/CMakeLists.txt ===
set (TRANSLATION_SOURCES
	kadu_cs.ts
	kadu_de.ts
	kadu_fr.ts
	kadu_it.ts
	kadu_pl.ts
)

qt4_add_translation (TRANSLATION_FILES ${TRANSLATION_SOURCES})

add_custom_target (translations DEPENDS ${TRANSLATION_FILES})
add_dependencies (kadu translations)

install (FILES ${TRANSLATION_FILES}
	DESTINATION ${KADU_DATA_DIR}/translations
)

=== modules/advanced_userlist/CMakeLists.txt ===
set (SOURCES
	advanced_userlist.cpp
	main.cpp
)

set (MOC_SOURCES
	advanced_userlist.h
)

set (TRANSLATION_SOURCES
	translations/advanced_userlist_de.ts
	translations/advanced_userlist_fr.ts
	translations/advanced_userlist_it.ts
	translations/advanced_userlist_pl.ts
)

set (CONFIGURATION_FILES
	configuration/advanced_userlist.ui
)

kadu_module (advanced_userlist
	MODULE_SOURCES ${SOURCES}
	MODULE_MOC_SOURCES ${MOC_SOURCES}
	MODULE_TRANSLATION_SOURCES ${TRANSLATION_SOURCES}
	MODULE_CONFIGURATION_FILES ${CONFIGURATION_FILES}
)

=== modules/alsa_sound/CMakeLists.txt ===
set (SOURCES
	alsa-device.cpp
	alsa-module.cpp
	alsa-player.cpp
)

set (MOC_SOURCES
	alsa-player.h
)

set (TRANSLATION_SOURCES
	translations/alsa_sound_de.ts
	translations/alsa_sound_fr.ts
	translations/alsa_sound_it.ts
	translations/alsa_sound_pl.ts
)

set (CONFIGURATION_FILES
	configuration/alsa_sound.ui
)

kadu_module (alsa_sound
	MODULE_SOURCES ${SOURCES}
	MODULE_MOC_SOURCES ${MOC_SOURCES}
	MODULE_TRANSLATION_SOURCES ${TRANSLATION_SOURCES}
	MODULE_CONFIGURATION_FILES ${CONFIGURATION_FILES}
)

pkg_search_module (ALSA REQUIRED alsa)

target_link_libraries (alsa_sound ${ALSA_LIBRARIES})
include_directories (${ALSA_INCLUDE_DIRS})

=== debian/changelog ===
kadu (0.9.0-1) unstable; urgency=low

  * New upstream release

 -- Patryk Cisek <patryk@debian.org>  Sun, 20 Mar 2011 09:12:01 +0100

kadu (0.6.6~rc3-1) unstable; urgency=low

  * New upstream release
  * Added libqtwebkit-dev to Build-Depends. (Closes: #618214)

 -- Patryk Cisek <patryk@debian.org>  Mon, 14 Mar 2011 09:25:25 +0100

kadu (0.6.6~rc2-1) unstable; urgency=low

  * New upstream release
  * Included information about XMPP protocol support in package descriptions
  * Changed "module(s)" to "plugin(s)" in package descriptions
  * Updated debian/patches/02-.config.patch to make it fit 0.6.6~rc2
  * Updated debian/patches/03-about-dialog.patch to make it fit 0.6.6~rc2
  * Removed debian/patches/04-gcc4.4-build-fix.patch, since it's no
    longer needed

 -- Patryk Cisek <patryk@debian.org>  Mon, 07 Mar 2011 15:16:01 +0100

kadu (0.6.6~rc1-1) unstable; urgency=low

  * New upstream release

 -- Patryk Cisek <patryk@debian.org>  Wed, 23 Feb 2011 16:28:39 +0100

kadu (0.6.6~beta17-2) unstable; urgency=low

  * Used wrap-and-sort from ubuntu-dev-tools to sort .install files, sort
    dependency fields in debian/control and wrap fields longer than 80
    characters
  * Added Vcs-Git and Vcs-Browser to debian/control
  * Added debian/build_kadu.sh script, which may be used to build Kadu
    packages when in Git checkout of Vcs-Git repository
  * Updated debian/README.source; added info about Vcs-* in
    debian/control, deleted CDBS info -- it's no longer used in Kadu
    packaging
  * Refreshed external modules list in debian/README.Debian

 -- Patryk Cisek <patryk@debian.org>  Mon, 21 Feb 2011 11:18:13 +0100

kadu (0.6.6~beta17-1) unstable; urgency=low

  * New upstream release
  * Added nextinfo external module

 -- Patryk Cisek <patryk@debian.org>  Sat, 19 Feb 2011 09:36:07 +0000

kadu (0.6.6~beta16-1) unstable; urgency=low

  * New upstream release
  * Added code.google.com to debian/watch
  * Refreshed debian/patches/02-.config.patch
  * Removed 05-panelkadu_no-strict-aliasing.patch, since panelkadu's
    been fixed upstream
  * Removed libcurl4-gnutls-dev from Build-Depends, since it's no longer
    needed
  * Added zlib1g-dev to Build-Depends
  * debian/handle_external.sh: externalthemes/icons is no longer
    taken care of.
  * Added libidn11-dev to Build-Depends
  * Added debian/patches/05-panelkadu_lednotify-build-fix.patch, that
    fixes panelkadu and lednotify build errors
  * Removed kadu05 icon theme from being installed

 -- Patryk Cisek <patryk@debian.org>  Thu, 17 Feb 2011 10:12:37 +0100

kadu (0.6.6~beta15-1) unstable; urgency=low

  * New upstream release
  * Bumped Standards-Version
  * Added dependency on libqt4-sql-sqlite for kadu package to make history
    module work properly
  * Updated Kadu Team members list in debian/copyright
  * Update of clean target in debian/rules: debian/alsa-stamp gets
    removed as well
  * Added metadata to debian/patches to make them comply DEP3
    http://dep.debian.net/deps/dep3
  * Updated debian/patches/* make them fit to new upstream version
  * Minor updates to debian/patches/* to make them fit new source
  * Setting 755 on /usr/share/kadu/themes/icons/oxygen/src/rebuild-
    statuses.sh
  * Updated external modules to their newest upstream versions
  * Added debian/patches/05-panelkadu_no-strict-aliasing.patch to get
    rid of compilation warning, which results in an error thanks to
    "-Werror" compilation flag

 -- Patryk Cisek <patryk@debian.org>  Fri, 11 Feb 2011 11:18:52 +0100

=== debian/control ===
Source: kadu
Section: net
Priority: optional
Maintainer: Patryk Cisek <patryk@debian.org>
Vcs-Git: git://git.debian.org/users/patryk/kadu.git
Vcs-Browser: http://git.debian.org/?p=users/patryk/kadu.git
Build-Depends: bzip2,
               cmake (>=2.6),
               debhelper (>= 7),
               libao-dev,
               libasound-dev,
               libaspell-dev,
               libaudio-dev,
               libdbus-1-dev,
               libgadu-dev,
               libidn11-dev,
               libmpdclient-dev,
               libphonon-dev,
               libqca2-dev,
               libqt4-dev,
               libqtwebkit-dev,
               libsndfile1-dev (>= 1.0),
               libxfixes-dev,
               libxss-dev,
               libxtst-dev,
               patchutils (>= 0.2.25),
               sharutils,
               x11proto-scrnsaver-dev,
               zlib1g-dev
Standards-Version: 3.9.1
Homepage: http://kadu.net

Package: kadu
Architecture: any
Depends: kadu-common (= ${source:Version}),
         libqca2-plugin-ossl,
         libqt4-sql-sqlite,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: kadu-external-modules
Conflicts: kadu-external-modules (<= 0.6.5.4.ds1-3)
Suggests: kadu-themes
Description: Gadu-Gadu/XMPP client for X11
 Gadu-Gadu is a Windows instant messenger, very popular in Poland.
 Kadu is a Qt4 client of Gadu-Gadu and XMPP for *nix systems.
 .
 This package provides Kadu along with plugins developed by Kadu developers.

Package: kadu-common
Architecture: all
Depends: libjs-mootools, ${misc:Depends}, ${shlibs:Depends}
Recommends: kadu-external-modules
Conflicts: kadu-external-modules (<= 0.6.5.4.ds1-3)
Suggests: kadu-themes
Description: Gadu-Gadu/XMPP client for X11
 Gadu-Gadu is a Windows instant messenger, very popular in Poland.
 Kadu is a Qt4 client of Gadu-Gadu and XMPP for *nix systems.
 .
 This package provides data common for all architectures.

Package: kadu-external-modules
Architecture: any
Depends: kadu (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: Additional plugins for Kadu
 Gadu-Gadu is a Windows instant messenger, very popular in Poland.
 Kadu is a Qt4 client of Gadu-Gadu and XMPP for *nix systems.
 .
 This package provides additional packages developed by external developers.
 See README.Debian for more details.

Package: kadu-themes
Architecture: all
Depends: ${misc:Depends}
Recommends: kadu (>= 0.5.0-1)
Description: Additional icons and emoticons for Kadu
 Gadu-Gadu is a Windows instant messenger, very popular in Poland.
 Kadu is a Qt4 client of Gadu-Gadu and XMPP for *nix systems.
 .
 This package provides additional icons, sounds and emoticons themes for
 Kadu.

=== debian/rules ===
#!/usr/bin/make -f
export DH_OPTIONS

PKG_DIR=$(shell pwd)
BUILD_DIR=$(CURDIR)/build-dir
INSTALL_DIR=$(PKG_DIR)/debian/tmp
DEB_BUILD_ARCH_OS := $(shell dpkg-architecture -qDEB_BUILD_ARCH_OS)

configure: configure-stamp
configure-stamp: debian/alsa-stamp
	dh_testdir
	mkdir $(BUILD_DIR)
	find . -name '*.o' -delete
	rm -f debian/kadu.install
	cp debian/kadu.install.noalsa debian/kadu.install
	bash debian/handle_external.sh copy
ifeq ($(DEB_BUILD_ARCH_OS),linux)
	cat debian/kadu.install.alsa >> debian/kadu.install
endif
	cd $(BUILD_DIR) && cmake -DCMAKE_BUILD_TYPE=Release -DCMAKE_INSTALL_PREFIX=/usr $(PKG_DIR)
	touch configure-stamp

#Architecture
build: build-arch build-indep

build-arch: build-arch-stamp
build-arch-stamp: configure-stamp
	cd $(BUILD_DIR) && $(MAKE)
	touch $@

build-indep: build-indep-stamp
build-indep-stamp: configure-stamp
	touch $@

clean: 
	dh_testdir
	dh_testroot
	rm -f build-arch-stamp build-indep-stamp configure-stamp debian/alsa-stamp
	test -d $(BUILD_DIR) && cd $(BUILD_DIR) && $(MAKE) clean || true
	rm -rf $(BUILD_DIR)
	bash debian/handle_external.sh remove
	cp -f debian/kadu.install.noalsa debian/kadu.install
	dh_clean 

install: install-indep install-arch
install-indep:
	dh_testdir
	dh_testroot
	dh_prep -i 
	dh_installdirs -i
	cd $(BUILD_DIR) && $(MAKE) DESTDIR=$(INSTALL_DIR) install
	# Remove all license files
	find $(INSTALL_DIR) -name '[lL][iI][cC][eE][nN][sS][eE].txt' -delete
	# Remove all thumbnails files
	find $(INSTALL_DIR) -name Thumbs.db -delete
	# Remove embedded JavaScript. Use the one that is in libjs-mootools
	rm -f $(INSTALL_DIR)/usr/share/kadu/syntax/chat/Gaia/Contents/Resources/Javascript/mootools.js
	ln -s /usr/share/javascript/mootools/mootools.js $(INSTALL_DIR)/usr/share/kadu/syntax/chat/Gaia/Contents/Resources/Javascript/mootools.js
	rm -f $(INSTALL_DIR)/usr/share/kadu/themes/sounds/bns/sound.conf~
	chmod 755 $(INSTALL_DIR)/usr/share/kadu/themes/icons/oxygen/src/rebuild-statuses.sh
	dh_install -i

install-arch:
	dh_testdir
	dh_testroot
	dh_prep -s 
	dh_installdirs -s
	cd $(BUILD_DIR) && $(MAKE) DESTDIR=$(INSTALL_DIR) install
	cp $(INSTALL_DIR)/usr/share/kadu/ChangeLog debian/kadu/usr/share/doc/kadu/about-changes-tab.txt
	rm -f $(INSTALL_DIR)/usr/share/kadu/modules/data/osd_hints/License
	dh_install -s

# Must not depend on anything. This is to be called by
# binary-arch/binary-indep
# in another 'make' thread.
binary-common:
	dh_testdir
	dh_testroot
	dh_installchangelogs 
	dh_installdocs
	dh_installexamples
	dh_installmenu
	dh_installman
	dh_link
	dh_strip
	dh_compress -XAUTHORS -XTHANKS -XLICENSE -Xabout-changes-tab.txt
	dh_fixperms
	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb
# Build architecture independant packages using the common target.
binary-indep: build-indep install-indep
	$(MAKE) -f debian/rules DH_OPTIONS=-i binary-common

# Build architecture dependant packages using the common target.
binary-arch: build-arch install-arch
	$(MAKE) -f debian/rules DH_OPTIONS=-s binary-common

binary: binary-arch binary-indep

debian/alsa-stamp:
ifeq ($(DEB_BUILD_ARCH_OS),linux)
	sed -i s/module_alsa_sound=n/module_alsa_sound=m/ $(PKG_DIR)/.config
else
	sed -i s/module_alsa_sound=m/module_alsa_sound=n/ $(PKG_DIR)/.config
endif
	touch $@

.PHONY: build clean binary-indep binary-arch binary install install-indep install-arch configure
